Index: proj_func.c
===================================================================
--- proj_func.c	(revision 290)
+++ proj_func.c	(revision 291)
@@ -189,147 +189,6 @@
     return atan2(gunner_get_y_screen(p) - mouse_y, mouse_x - gunner_get_x_screen(p));
 }
 
-struct menu {
-    rectangle_t *r0, *r1, *r2;
-    text_t      *t0, *t1, *t2;
-    rectangle_t *frame;
-};
-
-menu_t* (menu_ctor)(const font_t *fnt){
-    if(fnt == NULL) return NULL;
-    menu_t *ret = (menu_t*)malloc(sizeof(menu_t));
-    if (ret == NULL) return NULL;
-    ret->r0 = rectangle_ctor(0, 0, 400, 100);
-    ret->r1 = rectangle_ctor(0, 0, 400, 100);
-    ret->r2 = rectangle_ctor(0, 0, 400, 100);
-    ret->t0 = text_ctor(fnt, "PLAY");
-    ret->t1 = text_ctor(fnt, "TEST");
-    ret->t2 = text_ctor(fnt, "EXIT");
-    ret->frame = rectangle_ctor(0, 0, 800, 500);
-    if (ret->r0 == NULL || ret->r1 == NULL || ret->r2 == NULL ||
-        ret->t0 == NULL || ret->t1 == NULL || ret->t2 == NULL ||
-        ret->frame == NULL) return NULL;
-    // VISUAL
-    rectangle_set_fill_color(ret->r0, GRAPH_BLACK);
-    rectangle_set_outline_width(ret->r0, 2);
-    rectangle_set_outline_color(ret->r0, GRAPH_WHITE);
-    rectangle_set_fill_trans(ret->r0, GRAPH_TRANSPARENT);
-    rectangle_set_fill_color(ret->r1, GRAPH_BLACK);
-    rectangle_set_outline_width(ret->r1, 2);
-    rectangle_set_outline_color(ret->r1, GRAPH_WHITE);
-    rectangle_set_fill_trans(ret->r1, GRAPH_TRANSPARENT);
-    rectangle_set_fill_color(ret->r2, GRAPH_BLACK);
-    rectangle_set_outline_width(ret->r2, 2);
-    rectangle_set_outline_color(ret->r2, GRAPH_WHITE);
-    rectangle_set_fill_trans(ret->r2, GRAPH_TRANSPARENT);
-    text_set_valign(ret->t0, text_valign_center);
-    text_set_halign(ret->t0, text_halign_center);
-    text_set_color(ret->t0, TEXT_COLOR);
-    text_set_valign(ret->t1, text_valign_center);
-    text_set_halign(ret->t1, text_halign_center);
-    text_set_color(ret->t1, TEXT_COLOR);
-    text_set_valign(ret->t2, text_valign_center);
-    text_set_halign(ret->t2, text_halign_center);
-    text_set_color(ret->t2, TEXT_COLOR);
-    rectangle_set_fill_color(ret->frame, GRAPH_BLACK);
-    rectangle_set_outline_width(ret->frame, 6);
-    rectangle_set_outline_color(ret->frame, GRAPH_WHITE);
-    rectangle_set_fill_trans(ret->frame, GRAPH_TRANSPARENT);
-    // POSITIONS
-    rectangle_set_pos(ret->r0,
-                      graph_get_XRes()/2    - rectangle_get_w(ret->r0)/2,
-                      graph_get_YRes()*0.35 - rectangle_get_h(ret->r0)/2);
-
-
-    rectangle_set_pos(ret->r1,
-                    graph_get_XRes()/2    - rectangle_get_w(ret->r1)/2,
-                    graph_get_YRes()*0.5 - rectangle_get_h(ret->r1)/2);
-
-
-    rectangle_set_pos(ret->r2,
-                  graph_get_XRes()/2    - rectangle_get_w(ret->r2)/2,
-                  graph_get_YRes()*0.65 - rectangle_get_h(ret->r2)/2);
-
-    text_set_pos(ret->t0, rectangle_get_x(ret->r0)+rectangle_get_w(ret->r0)/2,
-                          rectangle_get_y(ret->r0)+rectangle_get_h(ret->r0)/2);
-
-    text_set_pos(ret->t1, rectangle_get_x(ret->r1)+rectangle_get_w(ret->r1)/2,
-                          rectangle_get_y(ret->r1)+rectangle_get_h(ret->r1)/2);
-
-    text_set_pos(ret->t2, rectangle_get_x(ret->r2)+rectangle_get_w(ret->r2)/2,
-                          rectangle_get_y(ret->r2)+rectangle_get_h(ret->r2)/2);
-
-    rectangle_set_pos(ret->frame,
-                  graph_get_XRes()/2    - rectangle_get_w(ret->frame)/2,
-                  graph_get_YRes()*0.5 - rectangle_get_h(ret->frame)/2);
-    return ret;
-}
-
-static int highlighted = -1;
-
-int (menu_update_state)(menu_t *menu, int click) {
-
-    if (rectangle_collide_point(menu->r0, mouse_x, mouse_y)) {
-        highlighted = GAME;
-        if (click) return GAME;
-    } else if (rectangle_collide_point(menu->r1, mouse_x, mouse_y)) {
-        highlighted = TEST;
-        if (click) return TEST;
-    } else if (rectangle_collide_point(menu->r2, mouse_x, mouse_y)) {
-        highlighted = EXIT;
-        if (click) return EXIT;
-    } else {
-        highlighted = -1;
-    }
-    return MENU;
-}
-
-void (menu_draw)(menu_t *menu) {
-    rectangle_draw(menu->frame);
-    switch (highlighted) {
-    case GAME:
-        rectangle_set_fill_color(menu->r0, HIGHLIGHT_COLOR);
-        rectangle_draw(menu->r0);
-        rectangle_draw(menu->r1);
-        rectangle_draw(menu->r2);
-        rectangle_set_fill_color(menu->r0, GRAPH_BLACK);
-        break;
-    case TEST:
-        rectangle_set_fill_color(menu->r1, HIGHLIGHT_COLOR);
-        rectangle_draw(menu->r0);
-        rectangle_draw(menu->r1);
-        rectangle_draw(menu->r2);
-        rectangle_set_fill_color(menu->r1, GRAPH_BLACK);
-        break;
-    case EXIT:
-        rectangle_set_fill_color(menu->r2, HIGHLIGHT_COLOR);
-        rectangle_draw(menu->r0);
-        rectangle_draw(menu->r1);
-        rectangle_draw(menu->r2);
-        rectangle_set_fill_color(menu->r2, GRAPH_BLACK);
-        break;
-    default:
-        rectangle_draw(menu->r0);
-        rectangle_draw(menu->r1);
-        rectangle_draw(menu->r2);
-        break;
-    }
-    text_draw(menu->t0);
-    text_draw(menu->t1);
-    text_draw(menu->t2);
-}
-
-void (menu_dtor)(menu_t *p){
-    rectangle_dtor(p->r0);
-    rectangle_dtor(p->r1);
-    rectangle_dtor(p->r2);
-    rectangle_dtor(p->frame);
-    text_dtor(p->t0);
-    text_dtor(p->t1);
-    text_dtor(p->t2);
-    free(p);
-}
-
 text_timer_t* (timer_ctor)(const font_t *fnt){
     if(fnt == NULL) return NULL;
     text_timer_t *ret = malloc(sizeof(timer_t));